<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\goods_category;


use app\common\model\goods_category\GoodsCategory;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * GoodsCategory逻辑
 * Class GoodsCategoryLogic
 * @package app\adminapi\logic\goods_category
 */
class GoodsCategoryLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/07 18:23
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            GoodsCategory::create([
                'pid' => $params['pid'],
                'category_type' => $params['category_type'],
                'picture' => $params['picture'],
                'name' => $params['name'],
                'is_goods' => $params['is_goods'],
                'status' => $params['status'],
                'weigh' => $params['weigh'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/07 18:23
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            GoodsCategory::where('id', $params['id'])->update([
                'pid' => $params['pid'],
                'category_type' => $params['category_type'],
                'picture' => $params['picture'],
                'name' => $params['name'],
                'is_goods' => $params['is_goods'],
                'status' => $params['status'],
                'weigh' => $params['weigh'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/07 18:23
     */
    public static function delete(array $params): bool
    {
        return GoodsCategory::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2024/07/07 18:23
     */
    public static function detail($params): array
    {
        return GoodsCategory::findOrEmpty($params['id'])->toArray();
    }

    public static function getTreeData():array
    {
        $data = GoodsCategory::field('id,pid,name')
            ->where('status', 1)
            ->order(['weigh' => 'desc', 'id' => 'desc'])
            ->select()
            ->toArray();
        foreach($data as $k => $v){
            $v['label'] = $v['name'];
            $v['value'] = $v['id'];
            $data[$k] = $v;
        }
        return linear_to_tree($data, 'children');
    }
}